unit Testu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, equation;

type
  TForm1 = class(TForm)
    Equation1: TEquation;
    ansFld: TEdit;
    varFld: TEdit;
    calcBtn: TButton;
    eqFld: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    numCompFld: TEdit;
    Label4: TLabel;
    TraceBtn: TButton;
    traceFld: TMemo;
    Label5: TLabel;
    procedure calcBtnClick(Sender: TObject);
    procedure eqFldExit(Sender: TObject);
    procedure varFldExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TraceBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.calcBtnClick(Sender: TObject);
var
  error : boolean;
  numComp, x : longInt;
  ans : extended;
begin
  numComp := strToInt(numCompFld.text);
  for x := 1 to numComp do
    ans := equation1.evaluate(error);
  ansFld.text := floatToStr(ans);
  if error then messageBeep(MB_ICONHAND);
end;

procedure TForm1.eqFldExit(Sender: TObject);
begin
  equation1.text := eqFld.text;
end;

procedure TForm1.varFldExit(Sender: TObject);
begin
  equation1.variable['x'] := strToFloat(varFld.text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  varFldExit(sender);
  eqFldExit(sender);
end;

procedure TForm1.TraceBtnClick(Sender: TObject);
var
  error : boolean;
  ans : extended;
  trace : tStringList;
  numComps, x : longInt;
begin
  trace := tStringList.create;
  numComps := strToInt(numCompFld.text);
  for x := 1 to numComps do
    ans := equation1.evaluateWithTrace(error, trace);
  ansFld.text := floatToStr(ans);
  traceFld.lines := trace;
  if error then messageBeep(MB_ICONHAND);
  trace.free;
end;

end.
