unit ThunkU;
{$ifndef WINDOWS}
  'This is suitable only for 16-bit Windows'
{$endif}
interface

uses
  WinTypes;

function NewMakeProcInstance(Proc: TFarProc; Instance: THandle): TFarProc;

procedure NewFreeProcInstance(Proc: TFarProc);

implementation

uses
  WinProcs, SysUtils;

type
  { Used by NewMakeProcInstance and NewFreeProcInstance }
  PProcInst = ^TProcInst;
  TProcInst = record
    Mov: Byte; DSeg: Word; { mov ax, seg @Data }
    Jmp: Byte; ProcAddr: Pointer; { jmp Addr + 3 }
    DataSelector: Word; { saved data selector }
  end;

function NewMakeProcInstance(Proc: TFarProc; Instance: THandle): TFarProc;
begin
  Result := GlobalAllocPtr(gmem_Share or gmem_Fixed, SizeOf(TProcInst));
  with PProcInst(Result)^ do
  begin
    Mov := $B8;
    DSeg := Instance;
    Jmp := $EA;
    ProcAddr := Proc;
    Inc(PtrRec(ProcAddr).Ofs, 3);
    DataSelector := PtrRec(Result).Seg;
{ Note that Delphi help is out of date - shouldn't free the code selector }
    PtrRec(Result).Seg := AllocDSToCSAlias(DataSelector);
  end;
end;

procedure NewFreeProcInstance(Proc: TFarProc);
begin
  PtrRec(Proc).Seg := PProcInst(Proc)^.DataSelector;
  GlobalFreePtr(Proc);
end;

end.
