{
 Designer: Craig Ward, 100554.2072@compuserve.com
 Date:     23/10/95
 Version:  1.0

 Function: Generic Filter Dialog. Sets\Remove filter on a table.
********************************************************************************}
unit Fltr;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, DBCtrls, DBTables, DB, SysUtils, Dialogs, Menus, Messages,
  ExtCtrls, Grids, DBGrids;

type
  TFilterDlg = class(TForm)
    btnFilter: TBitBtn;
    btnRemove: TBitBtn;
    HelpBtn: TBitBtn;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    comboFields: TComboBox;
    Table1: TTable;
    editFilter: TEdit;
    btnCancel: TBitBtn;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnFilterClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
    FTable: TFileName;                  {store's table on deactivate}
  public
    { Public declarations }
  end;

var
  FilterDlg: TFilterDlg;

implementation

{$R *.DFM}

{***form's preferences**********************************************************}
{activate}
procedure TFilterDlg.FormActivate(Sender: TObject);
var
 iStart, iInc: integer;
begin
 {compare table to previous call - if different then clear fields}
  if FTable <> table1.tablename then
   begin
    comboFields.Items.clear;
    editFilter.clear;
    iInc := Table1.FieldCount;
     for iStart:= 0 to (iInc-1) do
      begin
       comboFields.Items.Add( Table1.Fields[iStart].FieldName );
      end;
    comboFields.ItemIndex := 0;
  end
end;

{deactivate}
procedure TFilterDlg.FormDeactivate(Sender: TObject);
begin
 {deactivate table so next caller can change its properties}
 table1.active := false;
 {store table properties in field}
 FTable := Table1.tablename;
end;

{***buttons*********************************************************************}
{help}
procedure TFilterDlg.HelpBtnClick(Sender: TObject);
var
 n: integer;
begin
 n := FilterDlg.HelpContext;
 Application.HelpCommand(HELP_CONTEXT,n);
end;

{set filter}
procedure TFilterDlg.btnFilterClick(Sender: TObject);
begin
 if editFilter.text = '' then
  modalResult := mrCancel
 else
  modalResult := mrOK;
end;

{remove filter}
procedure TFilterDlg.btnRemoveClick(Sender: TObject);
begin
 comboFields.itemIndex := 0;
 editFilter.clear;
 modalResult := mrAbort;
end;


{cancel dialog}
procedure TFilterDlg.btnCancelClick(Sender: TObject);
begin
 modalResult := mrCancel;
end;

end.
