{$A+,B-,D-,F-,G+,I+,K+,L-,N+,P+,Q-,R-,S+,T+,V-,W-,X+,Y-}
unit FileCopy;
(*
  FILECOPY 1.0 (Public Domain)
  Borland Delphi 1.0
  Copr. (c) 1995-04-27 Robert E. Swart (100434.2072@compuserve.com)
                       P.O. box 799
                       5702 NP  Helmond
                       The Netherlands
  -----------------------------------------------------------------
  This unit implements a FastFileCopy procedure that is usable from
  Borland Pascal (real mode, DPMI and Windows) and Borland Delphi.

  Example of usage: FastFileCopy Source Dest

  uses FileCopy;
  begin
    FastFileCopy(ParamStr(1),ParamStr(2))
  end.
*)
interface

Type
  TCallBack = procedure (Position, Size: LongInt); { export; }

  procedure FastFileCopy(Const InFileName, OutFileName: String;
                         CallBack: TCallBack);

implementation
{$IFDEF VER80}
uses SysUtils;
{$ENDIF}

  procedure FastFileCopy(Const InFileName, OutFileName: String;
                         CallBack: TCallBack);
  Const BufSize = 4096;
  Type
    PBuffer = ^TBuffer;
    TBuffer = Array[1..BufSize] of Byte;
  var Size: Word;
      Buffer: PBuffer;
      infile,outfile: File;
      SizeDone,SizeFile: LongInt;
  begin
    if (InFileName <> OutFileName) then
    begin
      Assign(infile,InFileName);
      System.Reset(infile,1);
      SizeFile := FileSize(infile);
      Assign(outfile,OutFileName);
      System.Rewrite(outfile,1);
      SizeDone := 0;
      New(Buffer);
      repeat
        BlockRead(infile,Buffer^,BufSize,Size);
        Inc(SizeDone,Size);
        CallBack(SizeDone,SizeFile);
        BlockWrite(outfile,Buffer^,Size)
      until Size < BufSize;
      Dispose(Buffer);
      System.close(infile);
      System.close(outfile)
    end
    {$IFDEF VER80}
    else
      Raise EInOutError.Create('File cannot be copied onto itself')
    {$ENDIF}
  end {FastFileCopy};
end.

