unit Cur2a;

interface
{$R CURSORS.RES}
uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
  	Timer1: TTimer;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
	private
		{ Private declarations }
		procedure WMNCMouseMove(var AMessage:TMessage);message WM_NCMouseMove;
	public
  	{ Public declarations }
   	CursorCount:integer;
		DeadArea:BOOL;	{ True if NonClient Area }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
	Screen.Cursors[1]:=LoadCursor(HInstance,'ONE');
	Screen.Cursors[2]:=LoadCursor(HInstance,'TWO');
	Screen.Cursors[3]:=LoadCursor(HInstance,'THREE');
	Screen.Cursors[4]:=LoadCursor(HInstance,'FOUR');
	Cursor:=1;
	CursorCount:=0;
  Timer1.Interval:=100;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
	{ Calculate the next cursor }
	CursorCount:= (CursorCount+1) MOD 4;
	{ If in a valid region, Update cursor }
	if not DeadArea then
  	Cursor:=CursorCount+1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
	{ if this handler called, DeadArea must be false }
  DeadArea:=FALSE;
	{ Update Cursor }
	Cursor:=CursorCount+1;
end;

procedure TForm1.WMNCMouseMove(var AMessage:TMessage);
begin
	{ Detect that on form but invalid area }
  DeadArea:=TRUE;
  { Windows API Help says return 0 if message was handled }
	AMessage.Result:=0;
	inherited;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	Close;
end;

end.

