type
  TResBitmap = class(TBitmap)
  public
    constructor Create(ID: PChar);
  end;
constructor TResBitmap.Create(ID: PChar);
var
  HResInfo: THandle;
  BMF: TBitmapFileHeader;
  MemHandle: THandle;
  Stream: TMemoryStream;
  ResPtr: PByte;
  ResSize: Longint;
begin
  inherited Create;
  BMF.bfType := $4D42;
  HResInfo := FindResource(HInstance, ID, RT_Bitmap);
  ResSize := SizeofResource(HInstance, HResInfo);
  MemHandle := LoadResource(HInstance, HResInfo);
  ResPtr := LockResource(MemHandle);
  Stream := TMemoryStream.Create;
  Stream.SetSize(ResSize + SizeOf(BMF));
  Stream.Write(BMF, SizeOf(BMF));
  Stream.Write(ResPtr^, ResSize);
  FreeResource(MemHandle);
  Stream.Seek(0, 0);
  LoadFromStream(Stream);
  Stream.Free;
end;
