unit AutoMenu;

interface

uses
  SysUtils,WinTypes,WinProcs,Messages,Classes,
  Graphics,Controls,Forms,Dialogs,Menus,
  ToolProc; {contains call to aboutproc}

type
  TExtendedMenu = class(TMainMenu)
  private
    { Private declarations }
  protected
    { Protected declarations }
    procedure MenuClick(Sender: TObject);
    procedure AddItems;
    procedure CheckItems;
  public
    constructor Create(AOwner: TComponent); override;
    procedure Loaded; Override;
  published
  end;

implementation

constructor TExtendedMenu.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  if aOwner.name<>'' then  {added in design-mode or on the fly}
    AddItems;
end;

procedure TExtendedMenu.Loaded;
begin
  inherited Loaded;
  if Items.Count>0 then {read from stream, hook up click proc}
    CheckItems;
end;

{------------------------------------------------------------------------------}
{ TExtendedMenu.AddItems;                                                   
  }
{------------------------------------------------------------------------------}

procedure TExtendedMenu.AddItems;
var
  Menu:TMenuItem;
  Count:Longint;

  function MakeItem(const aCaption,aHint:String;aTag:Longint): TMenuItem;
  {add new item to the menu, it the tag is set point onclick to the
menuclick handler}
  begin
    Result:=TMenuItem.Create(Owner);
    with Result do begin
      Caption:=aCaption;
      Hint:=aHint;
      Tag:=aTag;
      if aTag>0 then
        OnClick:=MenuClick;
      end;
    Menu.Add(Result);
  end;

  function AddItem(const Caption,Hint:String): TMenuItem;
  {make an item and manage incrementing the count counter for conseq tags}
  begin
    if Caption='-' then {'just' a line}
      Result:=MakeItem(Caption,'',0)
    else begin
      Result:=MakeItem(Caption,Hint,Count);
      Count:=Count+1;
      end;
  end;

  procedure Add2Bar(const Caption,Hint,Name:String;aCount:longint);
  begin
    Menu:=TMenuItem(Components[0]);
    Count:=aCount;
    Menu:=AddItem(Caption,Hint);
    Menu.Name:=Name;
  end;


begin
  Add2Bar('&File','','MenuBarFile',1300);
  AddItem('&Exit','Exit the Application');

  Add2Bar('&Window','','MenuBarWindow',1100);
  AddItem('Cascade','');
  AddItem('Tile','');
  AddItem('Arrange Icons','');
  AddItem('Minimize All','');
  AddItem('Close All','');
  AddItem('Restore All','');

  Add2Bar('&Help','','MenuBarHelp',1200);
  AddItem('&Contents','See Help-Contents');
  AddItem('&Topic Search','Search for a Help-Topic');
  AddItem('&How to use Help','Information about using Help');
  AddItem('-','');
  AddItem('&About...','Shows About Box for this application');

end;

procedure TExtendedMenu.CheckItems;
var
  i,n,j,k:integer;
begin
  n:=items.count-1;
  for i:=0 to n do
    with Items[i] do begin
      k:=Count-1;
      if k>-1 then
        for j:=0 to k do
          with Self.Items[i].Items[j] do
            if (Tag>1100) and (Tag<1400) then
              OnClick:=MenuClick;
      end;
end;

{------------------------------------------------------------------------------}
{ TExtendedMenu.MenuClick                                                   
  }
{------------------------------------------------------------------------------}

procedure TExtendedMenu.MenuClick(Sender: TObject);
const
  a: char= #0;
var
  I: Integer;
begin
  with tForm(Owner) do
    case TMenuItem(Sender).Tag of
      1101: Cascade;
      1102: Tile;
      1103: ArrangeIcons;
      1104: for I := MDIChildCount - 1 downto 0 do
              MDIChildren[I].WindowState := wsMinimized;
      1105: for I := MDIChildCount - 1 downto 0 do
              MDIChildren[I].Close;
            {UpdateMenuItems(Sender);}
      1106: for I := 0 to  MDIChildCount - 1 do
              MDIChildren[I].WindowState:=wsNormal;

      1201: Application.HelpContext(0);
      1202: Application.HelpCommand(HELP_PARTIALKEY,longint(pointer(a)));
      1203: Application.HelpCommand(HELP_HelpOnHelp,0);
      1204: AboutBox;

      1301: Close;
      end;
end;

end.
