type
  PTableRec = ^TTableRec;
  TTableRec = record
    { The fields in the database - must match the physical table layout }
    ID     : longint;
    Name   : array[0..19] of char;
    Income : double;
    Age    : smallint;
  end;
var
  RecordBuffer     : pointer;
  RecordBufferSize : word;
  MaxInBuf         : longint;
  TableRecP        : PTableRec;
const
  MaxRecBufSize    : word = 32*1024;
  FldId            = 1;
  FldName          = 2;
  FldIncome        = 3;
  FldAge           = 4;

begin
  { Allocate a buffer to hold a number of records }
  MaxInBuf := MaxRecBufSize div SizeOf(TTableRec);
  RecordBufferSize := MaxInBuf  * SizeOf(TTableRec);
  GetMem(RecordBuffer, RecordBufferSize);

  try
    { Go to the first record in the pre-set range - use direct BDE-call }
    DbiRes := DbiSetToBegin(ReportTable.Handle);

    { Now loop until we are done or there is an error }
    NumInBuf  := MaxInBuf;
    DbiOk     := true;
    while (NumInBuf = MaxInBuf) and DbiOk do
    begin
      { Read a block of records - use direct BDE-call }
      DbiOk := (DbiReadBlock(ReportTable.Handle, NumInBuf, RecordBuffer) = DBIERR_NONE);

      { Loop through all records in the buffer }
      TableRecP := RecordBuffer;
      for i := 1 to NumInBuf do
      begin
        { Convert from raw to Pascal format }
        ConvertRecord(TableRecP^);
        { Collect statistics }
        CaclulateStatistics(TableRecP^);
        Inc(TableRecP);
      end;
    end;

  finally
    { De-allocate the buffer }
    FreeMem(RecordBuffer, RecordBufferSize);
  end;
end;
